import algds.IOUtils; // meine Version mit readLong()
/**
 * AlgDs WS99 Aufgabe 09.
 *
 * Ermittelt den gr&ouml;&szlig;ten gemeinsamen Teiler zweier Zahlen.
 * (Zahlen vom Typ long => bis 9*10^18)
 * &Uuml;berarbeitete Version mit Eingabe von der Konsole.
 *
 * @author Christian Semrau, 06.12.1999, 24.12.1999<br>
 * <a href="mailto:Christian.Semrau@student.uni-magdeburg.de">
 * Christian.Semrau@student.uni-magdeburg.de</a>
 */
public class ChS_Aufg09 {
/**
 * Liefert den gr&ouml;&szlig;ten gemeinsamen Teiler zweier
 * <code>long</code>-Zahlen.
 */
public static long ggT(long a, long b) {
  long r;
  do {
	r = a % b;		// Rest bilden
	a = b; b = r;	// Vorbereitung fuer naechsten Schritt
  } while (r != 0);	// solange Rest ungleich 0
  // der ggT ist jetzt in a
  return(a);
}

public static void main(String args[]) {
  System.out.println("AlgDs WS99 Aufgabe 9, Christian Semrau 06.12.1999");
  System.out.println("Bestimmt den groessten gemeinsamen Teiler zweier Zahlen.");

  System.out.print("Erste Zahl :"); long a = Math.abs(IOUtils.readLong());
  System.out.print("Zweite Zahl:"); long b = Math.abs(IOUtils.readLong());

  System.out.println("ggT(" + a + "," + b + ")=" + ggT(a,b));
}
} // class ChS_Aufg09